import Konva from 'konva';
import React, { ReactNode } from 'react';
import { StageProps } from 'react-konva';
export interface PortalStageProps extends StageProps {
    portalLayerProps?: Partial<Konva.LayerConfig>;
}
export interface PortalStageContextValue {
    mount: (children: ReactNode, zIndex: number) => number;
    update: (key: number, children: ReactNode, zIndex: number) => void;
    unmount: (key: number) => void;
}
export declare type MountBufferedAction = {
    type: 'mount';
    key: number;
    children: ReactNode;
    zIndex: number;
};
export declare type UpdateBufferedAction = {
    type: 'update';
    key: number;
    children: ReactNode;
    zIndex: number;
};
export declare type UnmountBufferedAction = {
    type: 'unmount';
    key: number;
};
export declare type BufferedAction = MountBufferedAction | UpdateBufferedAction | UnmountBufferedAction;
export declare function pendingPredicate(key: number): (item: BufferedAction) => boolean;
export declare const PortalStageContext: React.Context<PortalStageContextValue | null>;
export declare function PortalStage({ children, portalLayerProps, ...stageProps }: PortalStageProps): JSX.Element;
export default PortalStage;
